const fs = require("fs");
var diskspace = require("diskspace");
const args = require("yargs").argv;
var childProcess = require("child_process");

var pid = args.p;
var path = args.r
    ? "./results/add_random_csv_monitor.csv"
    : "./results/add_csv_monitor.csv";
var stream = fs.createWriteStream(path, {flags: "w+"});
stream.write("time,ram,disk\n");

var start_disk;

function init_monitor(){
  var net = require('net');
  const port = 9040;

  var server = net.createServer(function(socket) {
    socket.on("data", function(data){
      diskspace.check("/", function(err, result){
          var disk_used = result.used - start_disk;
          var ram_used = data;
          stream.write(Date.now() + "," + ram_used + "," + disk_used + "\n");
      });
    })
    socket.on("error", function(err){
      console.log("Error : " + err.message);
    })
  });

  server.listen(port, function() {});

  var monitor = childProcess.spawn('python',
    ["./unit_tests/monitor.py", "--p", pid],
    { stdio: 'inherit' });
}

process.on("exit", function(){
  monitor.kill();
})

diskspace.check("C", function (err, result){
    start_disk = result.used;
    init_monitor();
});
