import psutil
import os
import subprocess
import time

import argparse
parser = argparse.ArgumentParser(description='')
parser.add_argument("--p", type=int, help="pid")
args = parser.parse_args()

import socket
client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
client.connect(('localhost', 9040))

class _Snapshot(object):
  def get(self, property, default=None):
    return getattr(self, property, default)

class ProcessSnapshot(_Snapshot):
  def __init__(self, process=None):
    assert type(process) is psutil.Process
    self.username = process.username()
    self.process_object = process
    self.pid = process.pid
    # Memory percentage
    self.memory_percent = process.memory_percent()

  def update_memory_percent(self):
    if self.process_object.is_running():
      self.memory_percent = self.process_object.memory_percent()

process = psutil.Process(args.p)
snapshot = ProcessSnapshot(process)

while (1) :
    snapshot.update_memory_percent()
    client.send(str(snapshot.memory_percent))
    time.sleep(0.1)
